
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include <common.mqh>
#include <Patterns.mqh>


extern double Lots         = 1;  //lot size
extern int TakeProfit      = 0;  //Take Profit size (will be changed dynamically anyway)
extern int StopLoss        = 50; //Stop loss
extern bool UseRSI         = true; //Use RSI?
extern double Risk         =2.5;   //Money Management
extern double BreakEven    = 30;    // Profit Lock in pips  


// Internal variables:
int  digit=0;
bool firsttime = true;
double LotEquityRatio;
int Last_Order = 0;

int start()
  {
//----
   if (firsttime) { LotEquityRatio = AccountEquity()/Lots; firsttime = false;}

   digit  = MarketInfo(Symbol(),MODE_DIGITS);
   
   double sl, tp;
   
    
    Lots = NormalizeDouble((AccountEquity()/LotEquityRatio) * Risk,1); //Money Management

    
    if (Lots>50) {  Lots = 50;  }
    else if (Lots <0.1) { Lots = 0.1; }
    
    int    _orders = OrdersTotal();
    int result,macd,rsi,bands,zigzag;
    result = CheckCandles();


   if (_orders == 0)
   {

      double Equity_At_Buy = AccountEquity();
      
      double tp_b =  Bid + (TakeProfit * Point);
      double tp_s = Ask - (TakeProfit * Point);
      if (TakeProfit == 0) { 
      tp_b = 0; tp_s = 0; }
      
      double sl_b,sl_s;
      
      if (result == 1) { rsi = CheckRSI();  if (rsi ==1) { zigzag = CheckZigZag(); if (zigzag == 1)  // 1 = LONG
      {
            
              
               
               
               sl_b = Bid - (StopLoss * Point);
               
               buy(Lots,  sl_b ,tp_b, "");
               
               
               Last_Order = OP_BUY;
            
       
      }  }  }
     
      if (result == -1) { rsi = CheckRSI(); if (rsi ==-1) { zigzag = CheckZigZag(); if (zigzag == -1) // 2 = SHORT
      {
             
              
              
               
               sl_s = Ask + (StopLoss * Point);
               sell(Lots, sl_s ,tp_s , ""); 
               
             
               Last_Order = OP_SELL;
            
      }  }  }
   }
   if (_orders > 0)
   {
      double profit = getProfit(-1,-1); //get the order's profit
      if  (Last_Order == OP_BUY  && result ==-1 && profit  > 0) {  CloseAllOrders(); }  //If opposite signal appears, and the order made some cash, close it. 
      if  (Last_Order == OP_SELL && result == 1 && profit  > 0) {  CloseAllOrders(); }  //If opposite signal appears, and the order made some cash, close it. 
         
      if (getNumOpen(-1,-1)>0) { if (BreakEven>0) { TrailStops(); } } //If past the "break even" point, reposition stop losses to break even


   
     }
//----
   return(0);
  }
             
             
/////////////////////////////////////////////////////////////////////             

int CheckRSI()
 {
   if (!UseRSI) { return (true); }
   double rsi1 = iRSI(Symbol(),Period(),10,PRICE_CLOSE,0);
   double rsi2 = iRSI(Symbol(),Period(),10,PRICE_CLOSE,1);
   double rsi3 = iRSI(Symbol(),Period(),10,PRICE_CLOSE,2);
   if( rsi1>rsi2 && rsi3>rsi2){  return (1);  } //If RSI went up - down - up,        go LONG
   else if (rsi1<rsi2 && rsi3<rsi2) { return (-1); } //If RSI went down - up - down, go SHORT
   
  
   return(0);
}
////////////////////////////////////////////////////////////////////////////




int getNumOpen(int type = -1, int magic = -1) //Returns number of open orders for a given order type and magic number.
{
   int cnt;
   int num = 0;
   int total=OrdersTotal();
   for(cnt=total-1;cnt>=0;cnt--){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if((magic == -1 || OrderMagicNumber() == magic) && (type == -1 || OrderType() == type)){
         num++;
      }
   }
   return (num);
}

//+------------------------------------------------------------------+
void CloseAllOrders() //This opens a hundred orders, but only on live accounts, and only when you are asleep. Just kidding.
{
  
 
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
    RefreshRates();
    int type   = OrderType();
    int _ticket = OrderTicket();
    double _orderLots = NormalizeDouble(OrderLots(),1);
    
    bool result = false;
     
   
    
   switch(type)
   {
     //Close opened long positions
     case OP_BUY       : result = orderCloseReliable( _ticket, _orderLots, MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
                         break;
   
     //Close opened short positions
     case OP_SELL      : result = orderCloseReliable( _ticket, _orderLots, MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
                         break;
 

      //Close pending orders
      case OP_BUYLIMIT  :
      case OP_BUYSTOP   :
      case OP_SELLLIMIT :
      case OP_SELLSTOP  : result = orderDeleteReliable( _ticket);
    }
 
    if(result == false)
    {
      Alert("Order " , OrderTicket() , " failed to close. Error:" , GetLastError() );
      Sleep(3000);
      RefreshRates();
    }  
  }
  
 }
 
void TrailStops() //I used this code from someone. The function should be called Break Even cause thats what it does.
{        
    int total=OrdersTotal();
    for (int cnt=0;cnt<total;cnt++)
    { 
     OrderSelect(cnt, SELECT_BY_POS);   
     int mode=OrderType();    
        if ( OrderSymbol()==Symbol() ) 
        {
            if ( mode==OP_BUY )
            {
               if ( Bid-OrderOpenPrice()>Point*BreakEven ) 
               {
               double BuyStop = OrderOpenPrice();
               
               orderModifyReliable(OrderTicket(),OrderOpenPrice(),
                           NormalizeDouble(BuyStop, digit),
                           OrderTakeProfit(),0,LightGreen);
			      return(0);
			      }
			   }
            if ( mode==OP_SELL )
            {
               if ( OrderOpenPrice()-Ask>Point*BreakEven ) 
               {
               double SellStop = OrderOpenPrice();
               orderModifyReliable(OrderTicket(),OrderOpenPrice(),
   		                  NormalizeDouble(SellStop, digit),
   		                  OrderTakeProfit(),0,Yellow);	    
               return(0);
               }    
            }
         }   
      } 
}



int CheckZigZag() //Checks zigzag indicator. Only listen to candles if they are going OPPOSITE to the trend (defined by the zigzags).
{
   int n, i;
   double zag, zig;
   i=0;
   while(n<2)
   {
      if(zig>0) zag=zig;
      zig=iCustom(NULL, 0, "ZigZag", 0, i);
      if(zig>0) n+=1;
      i++;
   }  
   
   if(zag>zig) { return (1); }
   if(zig>zag) { return (-1); }

}   